/*global define, require, CKEDITOR, setTimeout*/
/*jslint regexp: true, unparam: true, nomen: true*/

// since jscoverage strips named defines, we mock the data directly as defined (in require.js)
require.s.contexts._.defined['de_epages/externalcontent/gadgetdialog/JSONGetGadgetInformation'] = {
    "GadgetGroups": [{
        "Alias": "Information",
        "Gadgets": [{
            "Alias": "RSS"
        }, {
            "Alias": "Maps"
        }, {
            "Alias": "Translation"
        }]
    }, {
        "Alias": "Multimedia",
        "Gadgets": [{
            "Alias": "ExternalVideo"
        }, {
            "Alias": "ContentSlider"
        }]
    }, {
        "Alias": "Social",
        "Gadgets": [{
            "Alias": "Facebook"
        }, {
            "Alias": "Twitter"
        }, {
            "Alias": "OtherButtons"
        }]
    }]
};

define([
    'testsuite/qunit',
    'jquery',
    'ep/ui/editor',
    'testsuite/qunit-fixture!ckeditor/plugins/eprss/plugin-test',

    '$ready!'
], function (QUnit, $, ep, fixture) {
    'use strict';

    ep('head').append('<link rel="stylesheet" type="text/css" href="../ckeditor/plugins/eprss/plugin-test.css">');

    QUnit.module("ckeditor/plugins/eprss", {
        teardown: fixture.destroy
    });

    QUnit.fixtureVar = fixture;

    QUnit.asyncTest("full eprss plugin test", function () {

        // Clear HTML-Remains, initiate Fixture and initiate Editor
        $('#qunit-fixture').nextAll().remove();
        QUnit.fixtureVar.init();
        ep('#uieditor_ckeditortestinstance_test1').uiEditor({
                'name' : 'ckeditortestinstance_test1',
                'blogPostMode': true
            });

        setTimeout(function () {
            var editorClass = 'cke_1',
                editorInstance = CKEDITOR.instances.uieditor_ckeditortestinstance_test1;

            // Reset CKE data.
            editorInstance.setData('');
            // Check if epgadget button exists.
            QUnit.equal(
                $('.' + editorClass + ' .cke_button__epgadget').length,
                1,
                'the necessary epgadget button exists'
            );
            // Open gadget dialog.
            $('.' + editorClass + ' .cke_button__epgadget').trigger('click');

            setTimeout(function () {
                var gadgetDialog = $('div.epDialog');

                QUnit.equal(
                    gadgetDialog.length,
                    1,
                    'gadget dialog is open'
                );
                QUnit.ok(
                    gadgetDialog.find('li').length > 0,
                    'gadgets found.'
                );

                gadgetDialog.find('li').eq(0).find('span').trigger('click');

                setTimeout(function () {
                    var buttonPane = $('div.uiDialogButtonPane > button'),
                        textInput = $('div.InputRow > #url.ep-uiInput-text');

                    QUnit.equal(
                        buttonPane.length,
                        2,
                        'RSS gadget dialog is open.'
                    );
                    QUnit.equal(
                        textInput.length,
                        1,
                        'URL-Input exists'
                    );

                    textInput.val('http://lorem-rss.herokuapp.com/');
                    textInput.trigger('keyup');

                    setTimeout(function(){
                        var successPane = $('div.InputRow > #url.ep-uiInput-text + span'),
                            previewNode = $('div.PreviewNode'),
                            textInput = $('div.InputRow > #url.ep-uiInput-text');

                        QUnit.ok(
                            successPane.hasClass('fail-icon'),
                            'fail-icon displayed'
                        );
                        QUnit.ok(
                            (previewNode.children().length === 0),
                            'no preview rendered'
                        );

                        textInput.val('http://lorem-rss.herokuapp.com/feed');
                        textInput.trigger('keyup');

                        setTimeout(function(){
                            var successPane = $('div.InputRow > #url.ep-uiInput-text + span'),
                                previewNode = $('div.PreviewNode');

                            QUnit.ok(
                                successPane.hasClass('success-icon'),
                                'success-icon displayed'
                            );
                            QUnit.ok(
                                (previewNode.children().length>0),
                                'preview rendered displayed'
                            );
                            QUnit.equal(
                                previewNode.find('li').length,
                                11,
                                'displaying 10 entries'
                            );
                            QUnit.equal(
                                previewNode.find('ul').hasClass('rss-feed-box'),
                                false,
                                'standart design active'
                            );

                            QUnit.ok(
                                (previewNode.find('.rss-content').length > 0),
                                'displaying content of rss entries'
                            );

                            $('select#numberOfEntries').val(3).trigger('change');
                            $('input#onlyHeadlines').trigger('click');
                            $('select#layout').val('box').trigger('change');

                            setTimeout(function () {
                                var previewNode = $('div.PreviewNode');

                                QUnit.equal(
                                    previewNode.find('li').length,
                                     4,
                                     'displaying 3 entries'
                                );
                                QUnit.ok(
                                    (previewNode.find('.rss-content').length === 0),
                                    'content of rss entries hidden'
                                );
                                QUnit.equal(
                                    previewNode.find('ul').hasClass('rss-feed-box'),
                                    true,
                                    'box design active'
                                );

                                setTimeout(function(){
                                    var okButton = $('div.ui-dialog-buttonpane.epDialogButtonBar > div > button:nth-child(1)');

                                    okButton.trigger('click');

                                    setTimeout(function () {
                                        var data = editorInstance.getData(),
                                            fragment = $("<div />").html(data),
                                            fakeElement = $(editorInstance.document.$.body).find('img.ep-gadget');

                                        QUnit.ok(
                                            fakeElement.length === 1,
                                            'ImageElement to display rss gadget in WYSIWYG was inserted'
                                        );
                                        QUnit.equal(
                                            fakeElement.data().epGadget.options.url,
                                            "http://lorem-rss.herokuapp.com/feed",
                                            'options written to imageElement'
                                        );
                                        QUnit.start();
                                    }, 200);

                                }, 500);

                            }, 500);

                        },2000);

                    },2000);

                }, 500);

            }, 1000);

        }, 4000);
    });
});



setTimeout(function () {

}, 500);
