/*jslint browser: true, nomen: true, regexp: true, plusplus: true*/
/*global define*/

var require, CKEDITOR, CKEDITOR_BASEPATH, CKEDITOR_AMD_REQUIRE,

    // CKEDITOR
    epages = {
        vars: {
            StyleUserDefinedColors: '#f00|#0f0|#0ff|#f0c'
        }
    };

require = (function (requirejs) {
    'use strict';

    // Polyfills for Phantom.js
    // - Number.isInteger polyfill (from https://github.com/byteball/ocore/issues/50)
    Number.isInteger = Number.isInteger || function(value) {
      return typeof value === 'number' &&
        isFinite(value) &&
        Math.floor(value) === value;
    };

    // - Array.filter polyfill
    if (Array.prototype.filter === undefined) {
      Array.prototype.filter = function(fn) {
        var filtered = [];

        for (var i=0, l=this.length; i<l; i++) {
            if (fn(this[i])) filtered.push(this[i]);
        }

        return filtered;
      };
    }

    var baseUrl = '../',
        deps = [],
        callback = function () {
            return;
        },

        file;

    if (window.__karma__) {
        // Set base url for karma environment
        baseUrl = '/base';

        // Push test files to dependencies stack for karma environment
        for (file in window.__karma__.files) {
            if (window.__karma__.files.hasOwnProperty(file)) {
                if (/-test.js$/.test(file)) {
                    // Convert file path to module path
                    file = file.replace(/^\/base\/(.*?)\.js$/, '$1');

                    // Add file as dependecy
                    deps.push(file);
                }
            }
        }

        // Set callback for karma environment
        callback = function () {
            window.__karma__.start();
        };

    } else if (/^.*?[\?|&]test=([^&]+).*$/.test(location.href)) {
        // Push test files if given as url get param
        file = location.href.replace(/^.*?[\?|&]test=([^&]+).*$/, '$1');
        deps.push(file);
    }

    CKEDITOR_BASEPATH = baseUrl + '/ckeditor/';

    CKEDITOR_AMD_REQUIRE = function (depends) {
        var i;

        for (i = 0; i < depends.length; i++) {
            depends[i] = (depends[i])
                .replace(CKEDITOR.basePath, 'ckeditor/')
                .replace(/(\.js(\?.*)?$)/, '');
        }

        return requirejs.apply(requirejs, arguments);
    };

    // RequireJS config
    requirejs.config({
        baseUrl: baseUrl,

        deps: deps,

        callback: callback,

        paths: {
            '$dict': 'require/$dict',
            '$i18n': 'require/$i18n',
            '$pub': 'require/$pub',
            '$ready': 'require/$ready',
            '$tmpl': 'require/$tmpl'
        },

        shim: {
            'backbone': {
                deps: ['underscore', 'jquery'],
                exports: 'Backbone'
            },
            'underscore': {
                exports: '_'
            },
            'fabric': {
                exports: 'fabric'
            },
            'ckeditor/ckeditor': {
                exports: 'CKEDITOR'
            },

            /*
             * Qunit testsuite modules
             */
            'testsuite/simulate': {
                deps: ['jquery'],
                exports: 'jQuery'
            },
            'testsuite/sinon': {
                exports: 'sinon'
            },
            'testsuite/sinon/ie': {
                deps: ['testsuite/sinon'],
                exports: 'sinon'
            },
            'testsuite/sinon/qunit': {
                deps: ['testsuite/sinon', 'testsuite/qunit'],
                exports: 'sinon'
            },
            'testsuite/sinon/server': {
                deps: ['testsuite/sinon'],
                exports: 'sinon'
            },
            'testsuite/sinon/timers-ie': {
                deps: ['testsuite/sinon', 'testsuite/simulate/timers'],
                exports: 'sinon'
            },
            'testsuite/sinon/timers': {
                deps: ['testsuite/sinon'],
                exports: 'sinon'
            }
        },

        config: {
            'ep': {
                maxContentLength: 4096,
                debugLevel: 2,
                languageId: '2',
                language: 'de',
                locale: 'de_DE',
                objectId: 0,
                viewAction: 'MBO-ViewTestcase',
                storeFrontUrl: 'http://www.DemoShop.de/Shop.sf',
                protocolAndServer: 'http://www.DemoShop.de',
                javascriptRoot: '../',

                // CKEDITOR
                features: {
                    Gadget: true,
                    Placeholder: true,
                    Blog: true,
                    Ebay: true
                },
                iconsRoot: 'myIconRoot',
                userDefinedColors: ['', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', ''],
                units: {"units":[{"value":"281","label":"Byte","abbr":"Byte","alias":"byte","show":true},{"value":"282","label":"Kilobyte","abbr":"kByte","alias":"kilobyte","show":true},{"value":"283","label":"Megabyte","abbr":"MByte","alias":"megabyte","show":true},{"value":"284","label":"Gigabyte","abbr":"GByte","alias":"gigabyte","show":true},{"value":"285","label":"Terabyte","abbr":"TByte","alias":"terrabyte","show":true},{"value":"259","label":"Gramm","abbr":"g","alias":"gram","show":true},{"value":"261","label":"Kilogramm","abbr":"kg","alias":"kilogram","show":true},{"value":"260","label":"Milligramm","abbr":"mg","alias":"milligram","show":true},{"value":"264","label":"Unze(n)","abbr":"oz","alias":"ounce","show":true},{"value":"263","label":"Pfund","abbr":"lb","alias":"pound","show":true},{"value":"262","label":"Tonne(n)","abbr":"t","alias":"tone","show":true},{"value":"250","label":"Liter","abbr":"l","alias":"litre","show":true},{"value":"254","label":"Kubikfuß","abbr":"ft³","alias":"cubicfoot","show":true},{"value":"253","label":"Kubikzoll","abbr":"in³","alias":"cubicinch","show":true},{"value":"252","label":"Kubikmeter","abbr":"m³","alias":"cubicmetre","show":true},{"value":"255","label":"Kubikyard","abbr":"yd³","alias":"cubicyard","show":true},{"value":"256","label":"Flüssigunze(n)","abbr":"fl oz","alias":"fluidounce","show":true},{"value":"257","label":"Gallonen","abbr":"gal","alias":"gallon","show":true},{"value":"251","label":"Milliliter","abbr":"ml","alias":"millilitre","show":true},{"value":"258","label":"Quart","abbr":"qt","alias":"quart","show":true},{"value":"243","label":"Meter","abbr":"m","alias":"metre","show":true},{"value":"244","label":"Zentimeter","abbr":"cm","alias":"centimetre","show":true},{"value":"247","label":"Fuß","abbr":"ft","alias":"foot","show":true},{"value":"248","label":"Zoll","abbr":"in","alias":"inch","show":true},{"value":"246","label":"Kilometer","abbr":"km","alias":"kilometre","show":true},{"value":"245","label":"Millimeter","abbr":"mm","alias":"millimetre","show":true},{"value":"249","label":"Yard","abbr":"yd","alias":"yard","show":true},{"value":"265","label":"Stück","abbr":"","alias":"piece","show":false},{"value":"267","label":"Flasche(n)","abbr":"","alias":"bottle","show":true},{"value":"268","label":"Kiste(n)","abbr":"","alias":"box","show":true},{"value":"278","label":"Dose(n)","abbr":"","alias":"can","show":true},{"value":"279","label":"Kapsel(n)","abbr":"","alias":"capsule","show":true},{"value":"269","label":"Karton(s)","abbr":"","alias":"carton","show":true},{"value":"280","label":"Glas","abbr":"","alias":"glass","show":true},{"value":"275","label":"Kit(s)","abbr":"","alias":"kit","show":true},{"value":"277","label":"Packung(en)","abbr":"","alias":"pack","show":true},{"value":"276","label":"Paket(e)","abbr":"","alias":"packet","show":true},{"value":"266","label":"Paar","abbr":"","alias":"pair","show":true},{"value":"274","label":"Rolle(n)","abbr":"","alias":"roll","show":true},{"value":"272","label":"Set(s)","abbr":"","alias":"set","show":true},{"value":"270","label":"Blatt","abbr":"","alias":"sheet","show":true},{"value":"273","label":"Ticket(s)","abbr":"","alias":"ticket","show":true},{"value":"271","label":"VKE","abbr":"","alias":"unit","show":true},{"value":"292","label":"Sekunde(n)","abbr":"s","alias":"second","show":true},{"value":"295","label":"Tag(e)","abbr":"","alias":"day","show":true},{"value":"294","label":"Stunde(n)","abbr":"","alias":"hour","show":true},{"value":"293","label":"Minute(n)","abbr":"min","alias":"minute","show":true},{"value":"298","label":"Monat(e)","abbr":"","alias":"month","show":true},{"value":"296","label":"Nacht","abbr":"","alias":"night","show":true},{"value":"297","label":"Woche(n)","abbr":"","alias":"week","show":true},{"value":"299","label":"Jahr(e)","abbr":"","alias":"year","show":true},{"value":"286","label":"Quadratmeter","abbr":"m²","alias":"squaremetre","show":true},{"value":"287","label":"Quadratzentimeter","abbr":"cm²","alias":"squarecentimetre","show":true},{"value":"290","label":"Quadratfuß","abbr":"ft²","alias":"squarefoot","show":true},{"value":"289","label":"Quadratzoll","abbr":"in²","alias":"squareinch","show":true},{"value":"288","label":"Quadratmillimeter","abbr":"mm²","alias":"squaremillimetre","show":true},{"value":"291","label":"Quadratyard","abbr":"yd²","alias":"squareyard","show":true}],"unitsHashByLabel":{"Byte":"281","Kilobyte":"282","Megabyte":"283","Gigabyte":"284","Terabyte":"285","Gramm":"259","Kilogramm":"261","Milligramm":"260","Unze(n)":"264","Pfund":"263","Tonne(n)":"262","Liter":"250","Kubikfuß":"254","Kubikzoll":"253","Kubikmeter":"252","Kubikyard":"255","Flüssigunze(n)":"256","Gallonen":"257","Milliliter":"251","Quart":"258","Meter":"243","Zentimeter":"244","Fuß":"247","Zoll":"248","Kilometer":"246","Millimeter":"245","Yard":"249","Stück":"265","Flasche(n)":"267","Kiste(n)":"268","Dose(n)":"278","Kapsel(n)":"279","Karton(s)":"269","Glas":"280","Kit(s)":"275","Packung(en)":"277","Paket(e)":"276","Paar":"266","Rolle(n)":"274","Set(s)":"272","Blatt":"270","Ticket(s)":"273","VKE":"271","Sekunde(n)":"292","Tag(e)":"295","Stunde(n)":"294","Minute(n)":"293","Monat(e)":"298","Nacht":"296","Woche(n)":"297","Jahr(e)":"299","Quadratmeter":"286","Quadratzentimeter":"287","Quadratfuß":"290","Quadratzoll":"289","Quadratmillimeter":"288","Quadratyard":"291"}}
            },
            'jquery/i18n': {
                region: 'de-DE',
                currency: ['EUR', 'GBP']
            },
            'jquery/dict': {
                region: 'de'
            },
            'jquery/storage': {
                namspace: '0::'
            },
            'jquery/metaparse': {
                type: 'data',
                name: 'js',
                autoparse: false
            },
            'util/mime': {
                groups: {
                    'image/*': 'image/png,image/jpeg,image/jpg,image/gif,image/vnd.microsoft.icon,image/x-icon,image/x-win-bitmap',
                    'document/*': 'application/pdf,application/msword,application/vnd.ms-excel,application/rtf,application/vnd.openxmlformats-officedocument.wordprocessingml.document,application/vnd.openxmlformats-officedocument.spreadsheetml.sheet',
                    'audio/*': 'audio/mpeg,audio/x-ms-wma,audio/ogg,audio/flac,audio/x-ms-wma',
                    'video/*': 'video/x-msvideo,video/mp4,video/mpeg,video/x-ms-wmv,video/x-flv'
                }
            },

            // CKEDITOR
            'ckeditor/config': {
                plugins: {
                    // Mediagallery cartridge
                    MediaGallery: {
                        position: 10,
                        name: 'epimage',
                        group: 'media'
                    },

                    // ExternalContent cartridge
                    Gadget: {
                        position: 20,
                        name: 'epgadget',
                        group: 'media'
                    },

                    // ExternalContent cartridge
                    Placeholder: {
                        position: 40,
                        name: 'epplaceholder'
                    },

                    // Forum cartridge
                    Blog: {
                        position: 10,
                        name: 'eppagebreak',
                        group: 'forum'
                    },

                    // Shop cartridge
                    Link: {
                        position: 10,
                        name: 'eplink',
                        group: 'various'
                    },

                    // Ebay cartridge
                    Ebay: {
                        position: 10,
                        name: 'epebay'
                    }
                },
                contentsCss: []
            }
        }
    });

    return requirejs;

}(this.requirejs));